import{s as mt,o as pt,n as ut}from"../chunks/scheduler.25b97de1.js";import{S as ft,i as ct,g as l,s as i,r as P,A as gt,h as r,f as n,c as s,j as st,u as A,x as h,k as lt,y as bt,a,v as L,d as E,t as M,w as G}from"../chunks/index.d9030fc9.js";import{T as rt}from"../chunks/Tip.baa67368.js";import{H as ht,E as wt}from"../chunks/EditOnGithub.91d95064.js";function $t(z){let o,u='Interested in adding a new quantization method to Transformers? Read the <a href="./contribute">HfQuantizer</a> guide to learn how!';return{c(){o=l("p"),o.innerHTML=u},l(d){o=r(d,"P",{"data-svelte-h":!0}),h(o)!=="svelte-1pyiy01"&&(o.innerHTML=u)},m(d,m){a(d,o,m)},p:ut,d(d){d&&n(o)}}}function qt(z){let o,u=`If you are new to the quantization field, we recommend you to check out these beginner-friendly courses about quantization
in colaboration with DeepLearning.AI:`;return{c(){o=l("p"),o.textContent=u},l(d){o=r(d,"P",{"data-svelte-h":!0}),h(o)!=="svelte-nysgts"&&(o.textContent=u)},m(d,m){a(d,o,m)},p:ut,d(d){d&&n(o)}}}function vt(z){let o,u,d,m,c,H,g,X="Quantization techniques focus on representing data with less information while also trying to not lose too much accuracy. This often means converting a data type to represent the same information with fewer bits. For example, if your model weights are stored as 32-bit floating points and they’re quantized to 16-bit floating points, this halves the model size which makes it easier to store and reduces memory-usage. Lower precision can also speedup inference because it takes less time to perform calculations with fewer bits.",k,p,U,f,F,b,J='<ul><li><a href="https://www.deeplearning.ai/short-courses/quantization-fundamentals-with-hugging-face/" rel="nofollow">Quantization Fundamentals with Hugging Face</a></li></ul>',D,w,Y='<ul><li><a href="https://www.deeplearning.ai/short-courses/quantization-in-depth/" rel="nofollow">Quantization in Depth</a></li></ul>',S,$,O,q,Z="The community has developed many quantization methods for various use cases. With Transformers, you can run any of these integrated methods depending on your use case because each method has their own pros and cons.",W,v,tt="For example, some quantization methods require calibrating the model with a dataset for more accurate and “extreme” compression (up to 1-2 bits quantization), while other methods work out of the box with on-the-fly quantization.",I,x,et="Another parameter to consider is compatibility with your target device. Do you want to quantize on a CPU, GPU, or Apple silicon?",B,y,nt="In short, supporting a wide range of quantization methods allows you to pick the best quantization method for your specific use case.",N,C,at="Use the table below to help you decide which quantization method to use.",R,_,ot='<thead><tr><th>Quantization method</th> <th>On the fly quantization</th> <th>CPU</th> <th>CUDA GPU</th> <th>RoCm GPU (AMD)</th> <th>Metal (Apple Silicon)</th> <th>torch.compile() support</th> <th>Number of bits</th> <th>Supports fine-tuning (through PEFT)</th> <th>Serializable</th> <th>🤗 transformers support</th> <th>Link to library</th></tr></thead> <tbody><tr><td><a href="./aqlm">AQLM</a></td> <td>🔴</td> <td>🟢</td> <td>🟢</td> <td>🔴</td> <td>🔴</td> <td>?</td> <td>1 / 2</td> <td>🟢</td> <td>🟢</td> <td>🟢</td> <td><a href="https://github.com/Vahe1994/AQLM" rel="nofollow">https://github.com/Vahe1994/AQLM</a></td></tr> <tr><td><a href="./awq">AWQ</a></td> <td>🔴</td> <td>🔴</td> <td>🟢</td> <td>🟢</td> <td>🔴</td> <td>?</td> <td>4</td> <td>🟢</td> <td>🟢</td> <td>🟢</td> <td><a href="https://github.com/casper-hansen/AutoAWQ" rel="nofollow">https://github.com/casper-hansen/AutoAWQ</a></td></tr> <tr><td><a href="./bitsandbytes">bitsandbytes</a></td> <td>🟢</td> <td>🔴</td> <td>🟢</td> <td>🔴</td> <td>🔴</td> <td>🔴</td> <td>4 / 8</td> <td>🟢</td> <td>🟢</td> <td>🟢</td> <td><a href="https://github.com/TimDettmers/bitsandbytes" rel="nofollow">https://github.com/TimDettmers/bitsandbytes</a></td></tr> <tr><td><a href="./eetq">EETQ</a></td> <td>🟢</td> <td>🔴</td> <td>🟢</td> <td>🔴</td> <td>🔴</td> <td>?</td> <td>8</td> <td>🟢</td> <td>🟢</td> <td>🟢</td> <td><a href="https://github.com/NetEase-FuXi/EETQ" rel="nofollow">https://github.com/NetEase-FuXi/EETQ</a></td></tr> <tr><td>GGUF / GGML (llama.cpp)</td> <td>🟢</td> <td>🟢</td> <td>🟢</td> <td>🔴</td> <td>🟢</td> <td>🔴</td> <td>1 - 8</td> <td>🔴</td> <td>🟢</td> <td><a href="../gguf">See GGUF section</a></td> <td><a href="https://github.com/ggerganov/llama.cpp" rel="nofollow">https://github.com/ggerganov/llama.cpp</a></td></tr> <tr><td><a href="./gptq">GPTQ</a></td> <td>🔴</td> <td>🔴</td> <td>🟢</td> <td>🟢</td> <td>🔴</td> <td>🔴</td> <td>4 / 8</td> <td>🟢</td> <td>🟢</td> <td>🟢</td> <td><a href="https://github.com/AutoGPTQ/AutoGPTQ" rel="nofollow">https://github.com/AutoGPTQ/AutoGPTQ</a></td></tr> <tr><td><a href="./hqq">HQQ</a></td> <td>🟢</td> <td>🔴</td> <td>🟢</td> <td>🔴</td> <td>🔴</td> <td>🟢</td> <td>1 - 8</td> <td>🟢</td> <td>🔴</td> <td>🟢</td> <td><a href="https://github.com/mobiusml/hqq/" rel="nofollow">https://github.com/mobiusml/hqq/</a></td></tr> <tr><td><a href="./quanto">Quanto</a></td> <td>🟢</td> <td>🟢</td> <td>🟢</td> <td>🔴</td> <td>🟢</td> <td>🟢</td> <td>2 / 4 / 8</td> <td>🔴</td> <td>🔴</td> <td>🟢</td> <td><a href="https://github.com/huggingface/quanto" rel="nofollow">https://github.com/huggingface/quanto</a></td></tr></tbody>',j,T,K,Q,V;return c=new ht({props:{title:"Quantization",local:"quantization",headingTag:"h1"}}),p=new rt({props:{$$slots:{default:[$t]},$$scope:{ctx:z}}}),f=new rt({props:{warning:!1,$$slots:{default:[qt]},$$scope:{ctx:z}}}),$=new ht({props:{title:"When to use what?",local:"when-to-use-what",headingTag:"h2"}}),T=new wt({props:{source:"https://github.com/huggingface/transformers/blob/main/docs/source/en/quantization/overview.md"}}),{c(){o=l("meta"),u=i(),d=l("p"),m=i(),P(c.$$.fragment),H=i(),g=l("p"),g.textContent=X,k=i(),P(p.$$.fragment),U=i(),P(f.$$.fragment),F=i(),b=l("blockquote"),b.innerHTML=J,D=i(),w=l("blockquote"),w.innerHTML=Y,S=i(),P($.$$.fragment),O=i(),q=l("p"),q.textContent=Z,W=i(),v=l("p"),v.textContent=tt,I=i(),x=l("p"),x.textContent=et,B=i(),y=l("p"),y.textContent=nt,N=i(),C=l("p"),C.textContent=at,R=i(),_=l("table"),_.innerHTML=ot,j=i(),P(T.$$.fragment),K=i(),Q=l("p"),this.h()},l(t){const e=gt("svelte-u9bgzb",document.head);o=r(e,"META",{name:!0,content:!0}),e.forEach(n),u=s(t),d=r(t,"P",{}),st(d).forEach(n),m=s(t),A(c.$$.fragment,t),H=s(t),g=r(t,"P",{"data-svelte-h":!0}),h(g)!=="svelte-1euzkei"&&(g.textContent=X),k=s(t),A(p.$$.fragment,t),U=s(t),A(f.$$.fragment,t),F=s(t),b=r(t,"BLOCKQUOTE",{"data-svelte-h":!0}),h(b)!=="svelte-xc6gln"&&(b.innerHTML=J),D=s(t),w=r(t,"BLOCKQUOTE",{"data-svelte-h":!0}),h(w)!=="svelte-1u47vvn"&&(w.innerHTML=Y),S=s(t),A($.$$.fragment,t),O=s(t),q=r(t,"P",{"data-svelte-h":!0}),h(q)!=="svelte-1dyd2u2"&&(q.textContent=Z),W=s(t),v=r(t,"P",{"data-svelte-h":!0}),h(v)!=="svelte-7cfitr"&&(v.textContent=tt),I=s(t),x=r(t,"P",{"data-svelte-h":!0}),h(x)!=="svelte-o9oe2x"&&(x.textContent=et),B=s(t),y=r(t,"P",{"data-svelte-h":!0}),h(y)!=="svelte-1xmraw"&&(y.textContent=nt),N=s(t),C=r(t,"P",{"data-svelte-h":!0}),h(C)!=="svelte-1nfyben"&&(C.textContent=at),R=s(t),_=r(t,"TABLE",{"data-svelte-h":!0}),h(_)!=="svelte-h4ee6j"&&(_.innerHTML=ot),j=s(t),A(T.$$.fragment,t),K=s(t),Q=r(t,"P",{}),st(Q).forEach(n),this.h()},h(){lt(o,"name","hf:doc:metadata"),lt(o,"content",xt)},m(t,e){bt(document.head,o),a(t,u,e),a(t,d,e),a(t,m,e),L(c,t,e),a(t,H,e),a(t,g,e),a(t,k,e),L(p,t,e),a(t,U,e),L(f,t,e),a(t,F,e),a(t,b,e),a(t,D,e),a(t,w,e),a(t,S,e),L($,t,e),a(t,O,e),a(t,q,e),a(t,W,e),a(t,v,e),a(t,I,e),a(t,x,e),a(t,B,e),a(t,y,e),a(t,N,e),a(t,C,e),a(t,R,e),a(t,_,e),a(t,j,e),L(T,t,e),a(t,K,e),a(t,Q,e),V=!0},p(t,[e]){const dt={};e&2&&(dt.$$scope={dirty:e,ctx:t}),p.$set(dt);const it={};e&2&&(it.$$scope={dirty:e,ctx:t}),f.$set(it)},i(t){V||(E(c.$$.fragment,t),E(p.$$.fragment,t),E(f.$$.fragment,t),E($.$$.fragment,t),E(T.$$.fragment,t),V=!0)},o(t){M(c.$$.fragment,t),M(p.$$.fragment,t),M(f.$$.fragment,t),M($.$$.fragment,t),M(T.$$.fragment,t),V=!1},d(t){t&&(n(u),n(d),n(m),n(H),n(g),n(k),n(U),n(F),n(b),n(D),n(w),n(S),n(O),n(q),n(W),n(v),n(I),n(x),n(B),n(y),n(N),n(C),n(R),n(_),n(j),n(K),n(Q)),n(o),G(c,t),G(p,t),G(f,t),G($,t),G(T,t)}}}const xt='{"title":"Quantization","local":"quantization","sections":[{"title":"When to use what?","local":"when-to-use-what","sections":[],"depth":2}],"depth":1}';function yt(z){return pt(()=>{new URLSearchParams(window.location.search).get("fw")}),[]}class Qt extends ft{constructor(o){super(),ct(this,o,yt,vt,mt,{})}}export{Qt as component};
